
local assets=
{
    Asset("ANIM", "anim/acefire.zip"),
    Asset("ANIM", "anim/swap_acefire.zip"),
 
    Asset("ATLAS", "images/inventoryimages/acefire.xml"),
    Asset("IMAGE", "images/inventoryimages/acefire.tex"),
}

local function canhealing(staff, caster, target, pos)
    if target.components.health.currenthealth < target.components.health.maxhealth then
       return true
    end 
    return false
end

 local function onblink(staff, pos, caster)
    if caster.components.sanity ~= nil then
        caster.components.sanity:DoDelta(-15)
    end
    
    end

local function onattack_acefire(inst, attacker, target)

    if attacker and attacker.components.hunger and attacker.components.health then
        attacker.components.hunger:DoDelta(-2)
		attacker.components.health:DoDelta(3)
    end
	if target.sg ~= nil and not target.sg:HasStateTag("frozen") then
        target:PushEvent("attacked", { attacker = attacker, damage = 0 })
    end

    if target.components.freezable ~= nil then
        target.components.freezable:AddColdness(1)
        target.components.freezable:SpawnShatterFX()
    end
end

local function onattack(inst, attacker, target)
    SpawnPrefab("ruins_statue_mage").Transform:SetPosition(target.Transform:GetWorldPosition())
    SpawnPrefab("collapse_small").Transform:SetPosition(target.Transform:GetWorldPosition())
    target:Remove()
end

local function fn()
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)

	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()
	
	inst.AnimState:SetBank("acefire")
    inst.AnimState:SetBuild("acefire")
    inst.AnimState:PlayAnimation("idle")
	
	if not TheWorld.ismastersim then
        return inst
    end
 
    local function OnEquip(inst, owner)
        owner.AnimState:OverrideSymbol("swap_object", "swap_acefire", "swap_acefire")
        owner.AnimState:Show("ARM_carry")
        owner.AnimState:Hide("ARM_normal")
    end
 
    local function OnUnequip(inst, owner)
        owner.AnimState:Hide("ARM_carry")
        owner.AnimState:Show("ARM_normal")
    end
 
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.keepondeath = true
    inst.components.inventoryitem.imagename = "acefire"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/acefire.xml"
     
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( OnEquip )
    inst.components.equippable:SetOnUnequip( OnUnequip )
	inst.components.inventoryitem.keepondeath = true
			
	inst:AddComponent("inspectable")
	
    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(300)
    inst.components.finiteuses:SetUses(300)
    inst.components.finiteuses:SetOnFinished(inst.Remove)
	
	inst:AddTag("shadow")
 	inst:AddComponent("weapon")
	inst.components.weapon:SetOnAttack(onattack_acefire)
    inst.components.weapon:SetDamage(50)
    inst.components.weapon:SetRange(8, 10)
	inst.components.weapon:SetProjectile("fire_projectile")
	inst.components.weapon:SetProjectile("bishop_charge")
	
	inst:AddComponent("blinkstaff")
    inst.components.blinkstaff.onblinkfn = onblink
	
	inst:AddComponent("tradable")
    inst.components.tradable.goldvalue = 6

    return inst
	
end
	
return  Prefab("common/inventory/acefire", fn, assets)