local assets =
{
    Asset("ANIM", "anim/coffee.zip"),
	
	Asset( "IMAGE", "images/inventoryimages/coffee.tex" ),
	Asset( "ATLAS", "images/inventoryimages/coffee.xml" ),
}

local prefabs =
{
    "spoiled_food",
	"meat",
	"coffee",
}

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBuild("coffee")
    inst.AnimState:SetBank("coffee")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("coffeeed")
	inst:AddTag("meat")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("edible")
    inst.components.edible.healthvalue = 150
    inst.components.edible.hungervalue = 200
	inst.components.edible.sanityvalue = 300

    inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

    inst:AddComponent("tradable")
	inst.components.tradable.goldvalue = 6

    inst:AddComponent("inspectable")

    inst:AddComponent("perishable")
    inst.components.perishable:SetPerishTime(TUNING.PERISH_SUPERSLOW)
    inst.components.perishable:StartPerishing()
    inst.components.perishable.onperishreplacement = "spoiled_food"

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "coffee"
	inst.components.inventoryitem.atlasname = "images/inventoryimages/coffee.xml"
  
    MakeHauntableLaunchAndPerish(inst)

    return inst
end

return Prefab("coffee", fn, assets, prefabs)