local assets =
{
    Asset("ANIM", "anim/conch.zip"),
	
	Asset("ATLAS", "images/inventoryimages/conch.xml"),
	Asset("IMAGE", "images/inventoryimages/conch.tex"),
}

local function onfinished(inst)
	if not inst.broken then
	inst:RemoveComponent("instrument")
	inst.broken = true
	end
end

local function HearPanFlute(inst, musician, instrument)
    if inst ~= musician and
        (TheNet:GetPVPEnabled() or not inst:HasTag("player")) and
        not (inst.components.freezable ~= nil and inst.components.freezable:IsFrozen()) and
        not (inst.components.pinnable ~= nil and inst.components.pinnable:IsStuck()) then
        if inst.components.sleeper ~= nil then
            inst.components.sleeper:AddSleepiness(10, TUNING.PANFLUTE_SLEEPTIME)
        elseif inst.components.grogginess ~= nil then
            inst.components.grogginess:AddGrogginess(10, TUNING.PANFLUTE_SLEEPTIME)
        else
            inst:PushEvent("knockedout")
        end
    end
end

local function TakeItem(inst, item, data)
	SpawnPrefab("green_leaves").Transform:SetPosition(inst:GetPosition():Get())
	inst.components.finiteuses:SetUses(300)
		if inst.broken then
	inst:AddComponent("instrument")
    inst.components.instrument:SetOnHeardFn(HearPanFlute)
	inst.broken = false
	end 
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

    inst:AddTag("flute")

    inst.AnimState:SetBank("conch")
    inst.AnimState:SetBuild("conch")
    inst.AnimState:PlayAnimation("idle")
	
	local light = inst.entity:AddLight()
    light:SetFalloff(0.5)
    light:SetIntensity(.8)
    light:SetRadius(0.5)
    light:SetColour(255/255,20/255,20/255)
    light:Enable(true)
	
	inst:AddTag("lightningrod")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("inspectable")
    inst:AddComponent("instrument")
    inst.components.instrument.range = TUNING.PANFLUTE_SLEEPRANGE
    inst.components.instrument:SetOnHeardFn(HearPanFlute)

    inst:AddComponent("tool")
    inst.components.tool:SetAction(ACTIONS.PLAY)

    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(300)
    inst.components.finiteuses:SetUses(300)
    inst.components.finiteuses:SetOnFinished( onfinished)
	
    inst.components.finiteuses:SetConsumption(ACTIONS.PLAY, 1)

	inst:AddComponent("fueled")
    inst.components.fueled.fueltype = FUELTYPE.NIGHTMARE
    inst.components.fueled.ontakefuelfn = TakeItem
    inst.components.fueled.accepting = true 
	
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "conch"
	inst.components.inventoryitem.atlasname = "images/inventoryimages/conch.xml"
	
	inst:AddComponent("fertilizer")
    inst.components.fertilizer.fertilizervalue = TUNING.POOP_FERTILIZE
    inst.components.fertilizer.soil_cycles = TUNING.POOP_SOILCYCLES
    inst.components.fertilizer.withered_cycles = TUNING.POOP_WITHEREDCYCLES
	
	inst:AddComponent("smotherer")
	
	inst:AddComponent("tradable")
    inst.components.tradable.goldvalue = 6
	
    MakeHauntableLaunch(inst)
    AddHauntableCustomReaction(inst, function(inst, haunter)
        if math.random() <= TUNING.HAUNT_CHANCE_HALF then
            if inst.components.finiteuses then
                inst.components.finiteuses:Use(1)
                inst.components.hauntable.hauntvalue = TUNING.HAUNT_MEDIUM
                return true
            end
        end
        return false
    end, true, false, true)

    return inst
end

return Prefab("conch", fn, assets)