local assets =
{
    Asset("ANIM", "anim/minalinsky.zip"),
	
	Asset("ATLAS", "images/inventoryimages/minalinsky.xml"),
    Asset("IMAGE", "images/inventoryimages/minalinsky.tex"),
}

local function onequip(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_body", "minalinsky", "swap_body")
	    if inst.components.container ~= nil then
        inst.components.container:Open(owner)
    end
end

local function onunequip(inst, owner) 
    owner.AnimState:ClearOverrideSymbol("swap_body")
	    if inst.components.container ~= nil then
        inst.components.container:Close(owner)
    end
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddNetwork()
	inst.entity:AddMiniMapEntity()
	inst.MiniMapEntity:SetIcon( "minalinsky.tex" )

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("backpack1")
    inst.AnimState:SetBuild("minalinsky")
    inst.AnimState:PlayAnimation("anim")
	inst:AddTag("backpack")

    inst.foleysound = "dontstarve/movement/foley/backpack"

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
    inst:AddComponent("inspectable")
	
	inst:AddTag("fridge")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "minalinsky"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/minalinsky.xml"

    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.BODY
	inst.components.equippable.walkspeedmult = TUNING.ARMORMARBLE_SLOW

    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)

    inst:AddComponent("container")
    inst.components.container:WidgetSetup("krampus_sack")
	
	inst:AddComponent("heater")
    inst.components.heater:SetThermics(false, true)
    inst.components.heater.equippedheat = TUNING.ICEHAT_COOLER
	
	inst:AddComponent("tradable")
    inst.components.tradable.goldvalue = 6

    return inst
end

return Prefab("common/inventory/minalinsky", fn, assets)